import { Component, ElementRef, OnInit, ViewChild, NgModule  } from '@angular/core'
import { Router, ActivatedRoute, Params } from '@angular/router'
import { FileService } from '../file.service'
import { HttpClient } from '@angular/common/http'
import { Observable, Subject } from 'rxjs'

@Component({
  selector: 'App-File-Upload',
  templateUrl: './file-upload.component.html',
  styleUrls: ['./file-upload.component.scss']
})

export class FileUploadComponent {
  filesToUpload: FileList = null;

  constructor(private httpClient:HttpClient, private router:Router) {}

  handleFileInput(files: FileList) {
      this.filesToUpload = files
  }

  uploadFileToActivity() {
    this.postFile(this.filesToUpload).subscribe(data => {
      // do something, if upload success
      if (data.id) {
        this.router.navigate([`/upload/${data.id}`])
      }
    }, error => {
      console.log(error);
    });
  }

  // send file
  postFile(filesToUpload: FileList): Observable<any> {
    const endpoint = '/api/v1/file/upload';
    const formData: FormData = new FormData();
    for (let i = 0; i < filesToUpload.length; i++){
      let file = filesToUpload.item(i)
      formData.append('file', file, file.name);
    }
    
    return this.httpClient
      .post(endpoint, formData)
}

  
}