import { Injectable } from '@angular/core';
import { HttpClient, HttpParams } from '@angular/common/http'
import { Observable } from 'rxjs'
import { saveAs } from 'file-saver';
import { FileSaverService } from 'ngx-filesaver';
import { ConstantPool } from '@angular/compiler';
const FileSaver = require('file-saver');

@Injectable({ providedIn: "root" })

export class ActionsService {
  
    constructor(private http: HttpClient) {}

    downloadFile(hash) {
        return this.http.get(`/api/v1/file/${hash}/file`, {responseType: "blob"})
    }

    editFile(hash) {
        return this.http.get(`/api/v1/file/${hash}/file`)
    }

    setFavorite(hash) {
        return this.http.put('/api/v1/user/favorite', { hash : hash })
    }

    getFile( sha256: string ): Observable<any> {
        let params = new HttpParams().set('sha256', sha256);
        return this.http.get(`/api/v1/file/${sha256}`, { params: params }) 
    }

    analyze(hash: string, isanalyzing:boolean){

    }
    
    setTags(hash, tags) {
        return this.http.put('/api/v1/file/tags', { hash : hash, tags : tags })
    }
}