import { Component, Input, SimpleChanges } from '@angular/core'
import { MatSnackBar } from "@angular/material/snack-bar";

@Component({
    selector: 'app-info-card',
    templateUrl: './info-card.component.html',
    styleUrls: ['./info-card.component.scss']
  })

export class InfoCardComponent {
    _dataSource


    @Input() 
    set dataSource(dataSource){
        this._dataSource = dataSource
    }
    constructor(private _snackBar: MatSnackBar){}


    ngOnInit(){

    }

    ngOnChanges(changes: SimpleChanges) {
        // only run when property "data" changed
      }

    copyToClipboard(data: String) {
        this.openSnackBar(`Copied ${data} to clipboard`)
    }

    openSnackBar(message: string) {
        this._snackBar.open(message, 'Dismiss', {
          duration:2000
        })
      }
}
