import { Directive, Input } from '@angular/core';
import { NgControl } from '@angular/forms';

@Directive({
  selector: '[bindQueryParam]',
})
export class BindQueryParamDirective {
  @Input('bindQueryParam') paramKey: string;

  constructor(private ngControl: NgControl) {}

  ngOnInit() {
    // Get parameters from URI and save them in queryParams.{}
    const queryParams = new URLSearchParams(location.search);

    // If query includes form-key, patch it's value from query
    if (queryParams.has(this.paramKey)) {
      this.ngControl.control.patchValue(queryParams.get(this.paramKey));
    }
  }
}