import { Component, OnInit } from '@angular/core';
import { NgForm } from '@angular/forms';
import { ActivatedRoute, Router } from '@angular/router';
import { ExecOptionsWithStringEncoding } from 'child_process';
import { FileService } from '../file.service';

@Component({
  selector: 'app-filter',
  templateUrl: './filter.component.html',
  styleUrls: ['./filter.component.scss']
})
export class FilterComponent implements OnInit {
  form: NgForm
  data
  text: string
  virustotal: string
  malwarebazar: string
  constructor(private router: Router, private route: ActivatedRoute, private fileservice: FileService) { }

  // when clicking search, copy values to data and set URL bar values / navigate
  search(form: NgForm) {
    this.data = {
      text: (form.value.text ? form.value.text : undefined),
      virustotal: (form.value.virustotal ? form.value.virustotal : undefined),
      malwarebazar: (form.value.malwarebazar ? form.value.malwarebazar : undefined),
    }

    this.router.navigate([''],{ queryParams: JSON.parse(JSON.stringify(this.data))}).then(() => {
      this.fileservice.filesUpdated.next(true)
    })
  }

  // reset the form to default/empty
  reset(form: NgForm) {
    form.resetForm()
  }

  
  ngOnInit(): void {
    // Map query parameters to filter component
    this.text = this.route.snapshot.queryParamMap.get('text') ? this.route.snapshot.queryParamMap.get('text') : undefined
    this.virustotal = this.route.snapshot.queryParamMap.get('virustotal') ? this.route.snapshot.queryParamMap.get('virustotal') : undefined
    this.malwarebazar = this.route.snapshot.queryParamMap.get('malwarebazar') ? this.route.snapshot.queryParamMap.get('malwarebazar') : undefined

  }

}
