import { HttpErrorResponse, HttpHandler, HttpInterceptor, HttpRequest, ɵHttpInterceptingHandler } from "@angular/common/http";
import { Injectable } from "@angular/core";
import { throwError } from "rxjs";
import { catchError } from "rxjs/operators"

export class ErrorInterceptor implements HttpInterceptor {

    intercept(req: HttpRequest<any>, next: HttpHandler) {
        return next.handle(req).pipe(
            catchError((error: HttpErrorResponse) => {
            console.log(error)
            alert(error.error.message)
            return throwError(error)
            })
        );
    }
}