/**
 * @desc Authorization-check for backend
 * @params req, res, args (request, response and arguments)
 * @res Will return true if authenticated/authorized, and send an immediate 401/403 if unauth.
 */
 module.exports.filefilter = function (files, user) {
     return new Promise((resolve, reject) => {

		exec();

		/**
		 * @desc Remove files if 
		 * @params req, res, args (request, response and arguments)
		 * @res Will return true if authenticated/authorized, and send an immediate 401/403 if unauth.
		 */
		function exec() {
			// Check all files in the array
            files.forEach(file => {
				// Check if student and exam tag is set, and if file is private
                if(isStudent(file) || isPrivate(file)) {
					// Remove that file from array if user should not have access
                    files.splice(files.map(function(e){return e.sha256}).indexOf(file.sha256), 1)
                }
            })
            resolve(files)
		}

		/**
		 * @desc Check if user is student, and if file contains student-limiting tag such as "exam"
		 * @params file - File to check user against
		 * @res Will return true if user is student and file has exam tag. Else false
		 */
		function isStudent(file) {
            if(user.db.role == 'student' && file.tags.includes('exam')) {
				return true
            } else {
                return false
            }
		}

		/**
		 * @desc Check if any tag is allowed
		 * @params userTags[]
		 * @res Will return true if any tags is in the list of allowed tags passed from middleware
		 */
		function isPrivate(file) {
			if(file.tags.includes('private') && !user.db.name == file.uploaded_by) {
                return true
            } else {
                return false
            }
		}
    })
};