const mongoose = require('mongoose')
const infologger = require('../logging/infologger')
const errorlogger = require('../logging/errorlogger')
mongoose.set('useUnifiedTopology', true)
mongoose.set('useCreateIndex', true)
mongoose.set('useNewUrlParser', true)
mongoose.set('useFindAndModify', false)

//Use the global promise with mongoose
mongoose.Promise = global.Promise

const url = "mongodb://128.39.140.120:27017/test"

//Mongoose options
const options = {
  autoIndex: true, 
  reconnectTries: Number.MAX_VALUE, // Never stop trying to reconnect
  reconnectInterval: 500, // Reconnect every 500ms  
  bufferMaxEntries: 0,
  connectTimeoutMS: 10000, // Give up initial connection after 10 seconds
  socketTimeoutMS: 45000, // Close sockets after 45 seconds of inactivity 
  serverSelectionTimeoutMS: 5000,
}


// Connect to the database
module.exports = () => {
    console.log('Establishing MongoDB connection...')  
    
    try{

      mongoose.connect( url, {
        "auth": { 
          "authSource": "admin" 
        }, 
        "user": "ubuntu", 
        "pass": "blueLima1" 
      }, options, () => {
        infologger.info("MongoDB connection established")
      }).catch(err => {
        console.log(err)
      })

      
    } catch (err) {
      errorlogger.error("Connection error: ", err)
    }

    mongoose.connection.once('open', () => {
      infologger.info('Connection successfull')
    })

    mongoose.connection.on('connected', () => {
      infologger.info('Connected to MongoDB event')
    })

    mongoose.connection.on('disconnected', () => {
      infologger.info("Disconnected from MongoDB event")
    })

    mongoose.connection.on('reconnected', () => {
      infologger.info("Reconnected to MongoDB event")
    })

    mongoose.connection.on('error', (err) => {
      errorlogger.error('Connection error:', err)
  })
}