const fileClass = require('../pipeline/fileclass')
const fileService = require('./file-service')
const archiver = require('archiver')
const fsPromises = require('fs').promises
const fs = require('fs')
const path = require('path')
archiver.registerFormat('zip-encrypted', require("archiver-zip-encrypted"))


class routeService {

  async reanalyze(hashes) {
    //turn hashes into array if it is string
    let array = (Array.isArray(hashes)) ? hashes : [hashes]
    array.map(hash => {
      fileService.findFile(hash).then(async (file) => {
        if (file && !file?.pending_analysis?.static_analysis) {
          // find file in storage, decrypt it and make a fileclass object with it in
          let path = await fileService.getDbFilePath(hash)
          await fileService.encryption(path, `${process.env.tempfilePath}/${hash}`, 'decrypt')
          new fileClass(process.env.tempfilePath, hash, { reanalyze: true })
        } else {
          console.log('Could not reanalyze file ', hash)
        }
      })
    })

  }

  async downloadFiles(hashes, password = 'infected', res) {
    await new Promise(async (resolve, reject) => {
      //turn hashes into array if it is string
      let array = (Array.isArray(hashes)) ? hashes : [hashes]
      console.log('DownloadArray: ', array)
      //create a zipfile
      let archive = archiver.create('zip-encrypted', { zlib: { level: 8 }, encryptionMethod: 'zip20', password: password })
      //append empty file with password
      archive.append('', { name: `${password}.password` });
      archive.pipe(res)
      //append files from storage to archive
      await Promise.all(
        array.map(async (hash) => {
          let filename = (await fileService.findFile(hash))?.original_filename
          if (filename) {
            console.log('Filename: ', filename)
            let inPath = path.resolve((await fileService.getDbFilePath(hash)))
            let outPath = path.resolve(`${process.env.tempdownload}${filename}`)
            console.log('in: ', inPath)
            console.log('out: ', outPath)
            await fileService.encryption(inPath, outPath, 'decrypt')
            await fsPromises.readFile(`${process.env.tempdownload}/${filename}`).then(async file => {
              console.log('read file: ', filename)
              archive.append(file, { name: filename })
              await fsPromises.rm(outPath)
              return
            }).catch(err => {
              console.error('Could not append file to archive', err)
            })
          } 
        }))
    
      archive.on('error', function (err) {
        console.error(err)
      })
      archive.on('finish', () => {
        console.log('finished')
        resolve(archive)
      })
      
      archive.finalize()
    })
  }
  
}

module.exports = new routeService()