const winston = require('winston');
require('winston-daily-rotate-file');

var errorTransport = new winston.transports.DailyRotateFile({

    //Specify information about the logfiles including where to store them
    name: 'errorlogger',
    level: 'error',
    filename: 'error-%DATE%.log',
    dirname: 'logging/errorlogs',
    datePattern: 'YYYY-MM-DD',
    zippedArchive: true,
    maxSize: '20m',
    maxFiles: '14d'
});

const errorlogger = winston.createLogger({
    //Formatting the log-message
    format: winston.format.combine(winston.format.timestamp(), winston.format.json()),
    
    //Where to ship the logs
    transports: [
        //To the console
        //new winston.transports.Console(),
        //To the errorTransport defined at line 4
        errorTransport
    ]
})

//Export the logger
module.exports = errorlogger;