const winston = require('winston');
require('winston-daily-rotate-file');

var userTransport = new winston.transports.DailyRotateFile({

    //Specify information about the logfiles
    name: 'userlogger',
    level: 'info',
    filename: 'userinfo-%DATE%.log',
    dirname: 'logging/infologs',
    datePattern: 'YYYY-MM-DD',
    zippedArchive: true,
    maxSize: '20m',
    maxFiles: '14d'
});

const userlogger = winston.createLogger({
    //Formatting the log-message
    format: winston.format.combine(winston.format.timestamp(), winston.format.json()),
    
    //Where to ship the logs
    transports: [
        //To the console
        //new winston.transports.Console(),
        //To the userTransport defined at line 4
        userTransport
    ]
})

//Export the logger
module.exports = userlogger;