const util = require("util");
const multer = require("multer");
const maxSize = 2 * 1024 * 1024 * 1024 * 1024 * 1024;

let storage = multer.diskStorage({
  destination: (req, file, cb) => {
    cb(null,process.env.tempfilePath);
  },
  filename: (req, file, cb) => {
    console.log(file.originalname)
    cb(null, file.originalname)
  },
})

let upload = multer({
  storage: storage,
  limits: { fileSize: maxSize },
}).array("file")

let uploadFileMiddleware = util.promisify(upload);
module.exports = uploadFileMiddleware;