const mongoose = require('mongoose')
const uniqueValidator = require("mongoose-unique-validator")

const uploadSchema = new mongoose.Schema({
  fileId: {
    type: String,
    required: true,
    unique: true
  },
  contains_compressed: {
    type: Boolean,
    default: false
  },
  unzipped: {
    type: Boolean,
    default: false
  },
  added_database: {
  type: Boolean,
  default: false
  },
  analyzed: {
  type: Boolean,
  default: false
  },
  analyze_queue: {
    type: Number,
    default: null
  },
  added_storage: {
    type: Boolean,
    default: false
  },
  splits: {
    type: [String]
  }
}) 

uploadSchema.plugin(uniqueValidator)

module.exports = mongoose.model('uploadStatus', uploadSchema)