const mongoose = require('mongoose')
const uniqueValidator = require("mongoose-unique-validator")

const userSchema = new mongoose.Schema({
    feide_id: { 
        type: String, 
        required: true, 
        unique: true,
        immutable: true
    },
    name:{
        type: String,
        required: true
    },
    role: { 
        type: String, 
        required: true
    },
    active: {
        type: Boolean,
        required: true,
        default: true
    },
    lastLogin: {
        type: Date
    },
    dateRegistered: {
        type: Date,
        default: Date.now,
        immutable: true
    },
    authored: {
        type: Boolean,
        default: false,
        required: true
    },
    tags: { type: [String] },
    favorites: { type: [String] }
}) 

userSchema.plugin(uniqueValidator)
/*
userSchema.prototype.validPass = function(pw) {
    return bcrypt.compareSync(pw, this.password);
 }
*/
module.exports = mongoose.model('user', userSchema)