const {post} = require('axios')
const FormData = require('form-data');

/**
 * @desc Get information about a certain file from malwarebazaar
 * @param string $hash - The HASH of the file 
 * @return Promise - malwarebazaar data of the file
*/  

const form = new FormData();

async function get_malwarebazaar(filehash) {
  form.append('query', 'get_info')
  form.append('hash', filehash)
  let response
  try {
    response = await post('https://mb-api.abuse.ch/api/v1/', form, { headers: form.getHeaders() })
  }catch(err) {
    console.error(err)
    return null
  }
  
  if (response.data.data){
    return response.data.data
  } else {
    return null
  }
  }
  module.exports.get_malwarebazaar = get_malwarebazaar